﻿namespace Dsl.Demo

import System
import System.IO
import System.Collections.Specialized
import System.Reflection

import Boo.Lang.Compiler
import Boo.Lang.Compiler.Ast
import Boo.Lang.Compiler.IO
import Boo.Lang.Compiler.Pipelines
import Boo.Lang.Compiler.Steps

class GlobalsToBaseClassExecute(AbstractCompilerStep):
	_baseTypeName as string
	_namespaces as StringCollection
	
	def constructor():
		pass
	
	def constructor(baseTypeName as string, namespaces as StringCollection):
		_baseTypeName = baseTypeName
		_namespaces = namespaces
	
	override def Run():
		module = CompileUnit.Modules[0]
		
		method = Method(Name: "Execute",
						Body: module.Globals)
						
		module.Globals = Block()
		
		loader = ClassDefinition(Name: module.Name)
		loader.BaseTypes.Add(SimpleTypeReference(_baseTypeName))
		loader.Members.Add(method)
		
		for member in module.Members:
			loader.Members.Add(member)
		
		for ns in _namespaces:
			module.Imports.Add( Import(Namespace: ns) )
		
		module.Members.Clear()
		module.Members.Add(loader)



